;
; Pilot Wings PATCH
; ROM Type: Non-Header
; rev 1.0-beta5
;
; CODER: Kurrono Kei
; DATE: 2018.01.01
;
; * tracks used and pulled from YouTube, not included with this patch
; Music Composers: Halc


; bug fixes in this version
; -------------------------
; fix1: same track 13 would play for 'LANDING FAILURE' 'LANDED OUT OF AREA' 'LANDING OK' 'GREAT LANDING', now
;		correct tracks will play - see aScreenL routine area for more commented details regarding track assignment
; fix2: bonus stage intro and music (before both had the same track), now intro is track19 and music is track 26
;
; fix3: helicopter crash missing msu and spc mute. Also silver pilotwings medal missing msu fixed.

lorom

; empty rom space to use, for pilotwings
; $00:8829 -> $00:88FF ; not much space here
; $00:EE6D -> $00:EFD0 ; longest free space to use for your code


; REGULAR game hook area START
org $00e539
JSR msuMuteH

org $00da79 ; password screen
JSR aScreen

org $00dd1f ; uses STA $2140, select flight mode
JSR aScreen

org $00d78c	; uses STX $2140, title screen music, no loop
JSR xScreen

org $00d88f ; uses STA $2140, course description intro music
JSR aScreen

org $00ee97 ; uses STA $2140, course description music, initial Tony
JSR aScreen

org $00d928 ; uses STA $2140, course description music, Tony/Shirley/Lance/BigAl
JSR aScreen

org $00e16a ; uses STX 2140, great landing in bonus stage
JSR xScreen

org $00e1ef ; uses STX $2140, after course finish
JSR xScreen

org $00e253 ; uses STX $2140, overall course
JSR xScreen

org $00e3cc ; uses STA $2140, got license, no loop
JSR aScreen

org $00e4bb ; uses STA $2140, secret mission screen 2
JSR aScreen

org $00e5a6 ; Pilotwings Medal
JSR aScreen

org $00e56a ; Secret Mission Pilotwings Medal
JSR aScreen

org $00e5b6 ; Staff Roll
JSR aScreen

org $00ed27 ; uses STA $2140, plane,skydive,rocketbelt,handglide,helicopter,bonus stage
JSR aScreen

org $00e6c5 ; uses STA $2140, game over screen
JSR aScreen

org $00e08c ; bonus stage intro and music, use A=13 for intro and X=1A for music via CMP/CPX?
JSR aScreen

org $01c535 ; helicopter crash 1
JSL aScreenL00
	NOP

org $01f138 ; helicopter crash 1
JSL aScreenL02
	NOP


; --> this is the jump that causes the helicopter rescue to crash, uses some kind of counter on A until track is played <---
org $01a26a ; Tony,Shirley,Lance are Rescued
JSL aScreenL08
    NOP
; --------------------------------------------------------------------
	
org $01bcf8 ; Mission Completed
JSL aScreenL
    NOP
	
org $01bcd0 ; uses LDA #$02 and STA $2140, rough landing, no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!

org $01f105 ; uses LDA #$02 and STA $2140, light plane - crash landing, no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
	
org $01f148 ; uses LDA #$02 and STA $2140, hang glider - bad landing,no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
	
org $01f159 ; uses LDA #$02 and STA $2140, rocket belt - bad landing,no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!	
	
org $01f165 ; uses LDA #$02 and STA $2140, skydiving - bad landing, no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
	
org $01f199 ; uses LDA #$02 and STA $2140, helicopter - bad landing, no loop
JSL aScreenL02 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
; REGULAR game hook area END


; hooks below need individual code areas as values are either decimal 13 for fail, 17 for good
; ---------------> START failed / success, special hooks <-----------------
org $01bcc5 ; uses LDA #$0D and STA $2140, bad landing - no loop
JSL aScreenL0D ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
	
org $01bcd6 ; uses LDA #$11 and STA $2140, not sure where track 17 goes? - no loop
JSL aScreenL11 ; this is a long jump, so using a long address at bank 01 with repeat msu code
	NOP ; do not delete!
; ---------------> END failed / success, special hooks <-----------------



; ---------------
; patch code area
; ---------------
org $00EE6D
xScreen:
	PHA
	LDA $2002
	CMP #$53 ; normal operation
	BEQ msuFoundX
	PLA
	STX $2140
	RTS
msuFoundX:
	PLA
	JSR msuX
	RTS

msuX:
	JSR spcMute
	PHA
	TXA ; transfer X to A for msuPlay/Loop routine
	JSR msuPlay
	CMP #$0D ; if equal to track 13, do not msu loop
	BNE gX0
gX0:
	CMP #$0C ; if equal to track 12, do not msu loop
	BNE resumeX
	LDA #$01
	JMP hereX
resumeX:
	LDA #$03 ; loop
hereX:
	JSR msuLoop
	PLA
	RTS
	
; -------------------------------------------------------------------


aScreen:
	PHA
	LDA $2002
	CMP #$53 ; normal operation
;	CMP #$20 ; debugging operation
	BEQ msuFoundA
	PLA
	STA $2140
	RTS
msuFoundA:
	PLA
	JSR msuA
	RTS

msuA:
	JSR spcMute
	PHA
	CPX #$1A ; if equal to 0A, play track 26
	BEQ play0A
	JMP here0A
play0A:
	LDA #$1A ; load track 26 to play bonus stage music
here0A:
	JSR msuPlay
	CMP #$09 ; if equal to 09, do not msu loop, license awarded
	BEQ resumeA
	CMP #$13 ; if equal to 13, do not msu loop, bonus stage intro
	BNE resumeA
	LDA #$01 ; loop value
	JMP hereA
resumeA:
	LDA #$03 ; no loop value
hereA:
	JSR msuLoop
	PLA
	RTS

; --------
; spc mute
; --------
spcMute:
	PHA
	LDA #$00 ; this value in A mutes spc when written to $2140
	STA $2140
	PLA
	RTS

; --------
; msu mute
; --------
msuMute:
	STZ $2007
	RTS

msuMuteH:
	STZ $2007
	STA $2140
	RTS
	
; ------------
; msu1 routine
; ------------
msuPlay:
	PHA
	STZ $2006
	STA $2004
	STZ $2005
loopTitle:
	BIT $2000
	BVS loopTitle ; track not ready
	BRA mo
msuVolume:
mo:
	LDA #$FF ; max volume
	STA $2006
	PLA
	RTS
msuLoop:
	STA $2007
	RTS
	
	
; empty space in bank 01C4F5, need since one routine jumps long
org $01C4F5

;code by Conn---------------------------------------------
aScreenL08:
	CMP #$00
	BNE $05
	LDA #$08 ; run normal msu Routine if A is 00 to play track 08 (avoid loading msu between 01-FF)
	JMP aScreenL
	LDA $2002
	CMP #$53
	BEQ $06   ; make spc mute if in msu mode
	LDA #$08  ; if in spc mode, execute native code
	STA $2140
	RTL
	LDA #$00
	STA $2140
	RTL
	
;-------------------------------------------------------
aScreenL02:
	LDA #$02 ; track 2, 'LANDING FAILURE' 'LANDED OUT OF AREA'
	JMP aScreenL
aScreenL00:
	LDA #$08 ; track 8, HELICOPTER RESCUE SUCCESSFUL?
	JMP aScreenL
aScreenL0D:
	LDA #$0D ; track 13, 'LANDING OK' 'GREAT LANDING'
	JMP aScreenL
aScreenL11:
	LDA #$11 ; track 17, not sure? failed, maybe?
aScreenL:
	PHA
	LDA $2002
	CMP #$53 ; normal operation
	BEQ msuFoundAL
	PLA
	STA $2140
	RTL
msuFoundAL:
	PLA
	JSL msuAL
	RTL

msuAL:
	JSL spcMuteL
	PHA
	JSL msuPlayL
	LDA #$01 ; no-loop
	JSL msuLoopL
	PLA
	RTL

; --------
; spc mute
; --------
spcMuteL:
	PHA
	LDA #$00 ; this value in A mutes spc when written to $2140
	STA $2140
	PLA
	RTL

; --------
; msu mute
; --------
msuMuteL:
	STZ $2007
	RTL

; ------------
; msu1 routine
; ------------
msuPlayL:
	PHA
	STZ $2006
	STA $2004
	STZ $2005
loopTitleL:
	BIT $2000
	BVS loopTitleL ; track not ready
	LDA #$FF ; max volume
	STA $2006
	PLA
	RTL
msuLoopL:
	STA $2007
	RTL